#!/bin/sh
# This is the -*-fundamental-*- source file from which the C News
# and INN versions of dodexpire are extracted.
# DON'T run this file through "subst" - do that with the extracted file

case "$1" in
C*)	ex='s/^\#\#C *//' ;;
I*)	ex='s/^\#\#I *//' ;;
*)	exit 1;
esac

#-----------------------------------------------------------------------------#
exec	sed -e '/^\#\#F/r funcs.SH' <<'_END_OF_SCRIPT_' |\
	sed -e "$ex" -e '/^\#\#/d'
#!/bin/sh
# dodexpire - overall administration for dexpire
##C # C News spacelist version
##I # INN spacelist version

##C # =()<. ${NEWSCONFIG-@<NEWSCONFIG>@}>()=
##C . ${NEWSCONFIG-/var/lib/news/bin/config}
##I # =()<. @<_PATH_SHELLVARS>@>()=
##I . /var/lib/news/innshellvars
##I NEWSCTL=$NEWSLIB # for compatibility

##C PATH=$NEWSCTL/bin:$NEWSBIN/expire:$NEWSBIN/nov:$NEWSBIN:$NEWSPATH
##I PATH=${NEWSBIN}:${PATH}:/bin:/usr/bin
export PATH NEWSCTL
##C umask $NEWSUMASK
##I umask 002

cd $NEWSCTL
errs=dodex.$$
##C log=dexpire.log
##I log=${MOST_LOGS}/dexpire.log
me=`basename $0`
##C splist=$NEWSBIN/expire/splist.awk
##I splist=$NEWSBIN/splist.awk
rm -f $errs || exit 1
##F

##C Lock=LOCKexpire
##I Lock=${LOCKS}/LOCKexpire
##C lock -o $Lock $$ || {
##I shlock -f $Lock -p $$ || {
	cat <<EOF | report "$me: locked"
$me encountered LOCKexpire, won't start two expire processes concurrently
EOF
	exit 0
}
status=1
##C trap 'rm -f $errs ; unlock $Lock ; trap 0 ; exit $status' 0 1 2 15
##I trap 'rm -f $errs $Lock ; trap 0 ; exit $status' 0 1 2 15

if [ -s expires.dir ]; then
	# Run "runexp" and rebuild the expires database
	runexp -v >> $log 2>> $errs
	checkerr runexp
	dbz -f expires expires.n 2>> $errs
	checkerr dbz expires.n
	rm -f expires expires.dir expires.pag
	mv expires.n expires
	mv expires.n.pag expires.pag
	mv expires.n.dir expires.dir
else
	newexpires
fi

# Run "dexpire" if not in daemon mode
daemons=`echo LDexp.*`
awk -f $splist $NEWSCTL/spacelist | \
 while read fsys da db ino blk; do
	if ! fgrep "$fsys" $daemons >/dev/null 2>&1; then
		dexpire -u $v -S$fsys -i$ino -f$blk >> $log 2>> $errs
		checkerr dexpire $fsys
	fi
 done

##I # Check to see if we were out of disk space
##I ctlinnd mode > $errs 2>&1
##I egrep -s '"No space left on device writing .* file -- throttling"' $errs
##I tstatus=$?
##I if [ $tstatus = 0 ]; then
##I 	ctlinnd -s go ''
##I 	(echo "Unthrottled innd after running dexpire:"
##I 	 cat $errs ) | report "$me problems (spool was full)"
##I fi
##I rm -f $errs

##C # Renumber the active file
##C if [ -x $NEWSBIN/expire/updatemin ]; then
##C	updatemin 2>> $errs
##C	checkerr updatemin
##C else
##C 	upact 2>> $errs
##C 	checkerr upact
##C fi

##C # Expire the overview database
##C expov 2>> $errs
##C checkerr expov

status=0
exit 0
_END_OF_SCRIPT_
