#!/bin/sh
# This is the -*-fundamental-*- source file from which the C News
# and INN versions of dohisttrim are extracted.
# DON'T run this file through "subst" - do that with the extracted file

case "$1" in
C*)	ex='s/^\#\#C *//' ;;
I*)	ex='s/^\#\#I *//' ;;
*)	exit 1;
esac

#-----------------------------------------------------------------------------#
exec	sed -e '/^\#\#F/r funcs.SH' <<'_END_OF_SCRIPT_' |\
	sed -e "$ex" -e '/^\#\#/d'
#!/bin/sh
# dohisttrim - trim the history file and rebuild the dbz database
##C # C News version
##I # INN version

##C # =()<. ${NEWSCONFIG-@<NEWSCONFIG>@}>()=
##C . ${NEWSCONFIG-/var/lib/news/bin/config}
##I # =()<. @<_PATH_SHELLVARS>@>()=
##I . /var/lib/news/innshellvars
##I NEWSCTL=$NEWSLIB # for compatibility

##C PATH=$NEWSCTL/bin:$NEWSBIN/expire:$NEWSBIN:$NEWSPATH
##I PATH=$NEWSBIN:$PATH:/bin:/usr/bin
export PATH NEWSCTL
##C umask $NEWSUMASK
##I umask 002
##F

v=""
m="-m14"
c="-c120"
T="$NEWSLIB"
fuser=""
stime=1
f=""
while [ "$1" ]; do
	case "$1" in
		-v)  v=$1 ;;
		-m)  m=${2-$m}; shift ;;
		-m*) m=$1 ;;
		-c)  c=${2-$c}; shift ;;
		-c*) c=$1 ;;
		-T)  T=${2-$T}; shift ;;
		-k)  fuser=fuser; stime=20 ;;
		-f)  f=$1 ;;
	esac
	shift
done

##C Lock=LOCKexpire
##I Lock=${LOCKS}/LOCKexpire
##C lock -o $Lock $$ || {
##I shlock -f $Lock -p $$ || {
	cat <<EOF | report "$me: locked"
$me encountered LOCKexpire, won't start two expire processes concurrently
EOF
	exit 0
}

if [ ! -d "$T" ]; then
	echo "temp directory `$T' does not exist!"
	exit 1
fi
cd $NEWSCTL
errs=dohist.$$
nhistory=$T/history.n
##C log=dexpire.log
##I log=${MOST_LOGS}/dexpire.log
me=`basename $0`
rm -f $errs $nhistory || exit 1
status=1
allhistory="history history.dir history.pag"

##C lock LOCK $$ 30 || exit 1
##C trap 'rm -f $errs; unlock LOCK; unlock LOCKexpire; trap 0; exit $status' 0 1 2 15
##I mesg="Rebuilding history file [$$]"
##I mesg2="Try again in a few minutes ($mesg)"
##I r=1
##I while [ "$r" ]; do
##I 	x=`ctlinnd -s -t0 pause "$mesg" 2>&1`
##I 	case "$x" in
##I 	'')		r="" ;;
##I 	Already*) 	sleep 120 ;;
##I 	*)		echo "$x" > $errs; 
##I 			checkerr ctlinnd pause ;;
##I 	esac
##I done
##I if [ "$fuser" ]; then
##I	ctlinnd -s readers n "$mesg2" 2>/dev/null
##I 	trap 'rm -f $Lock $errs; ctlinnd -s go "$mesg"; ctlinnd -s readers y "$mesg2"; trap 0; exit $status' 0 1 2 15
##I else
##I 	trap 'rm -f $Lock $errs; ctlinnd -s go "$mesg"; trap 0; exit $status' 0 1 2 15
##I fi

if [ "$fuser" ]; then
	$fuser -s -k -TERM $allhistory
	sleep $stime
fi
if [ -z "$f" ]; then
	size="`sizeof $allhistory`"
##C 	if [ " `spacefor $size control`" -le 0 ];
##I 	if [ "$size" -gt "`diskspace $T`" ];
	then
		cat <<EOF | report -u "$me problems (Disk full)"
SEVERE SPACE SHORTAGE in $T! ($size bytes needed)
Unable to rebuild history files due to insufficient space for
temporaries. Since dexpire doesn't free space in this partition,
human action is urgently needed.
EOF
		exit 1
	fi
fi

if [ ! -s expires.dir ]; then
	newexpires
fi
histtrim -u $v $m $c -p3 >>$log 2>&1 3>$nhistory
checkerr histtrim

dbz -u -f history $nhistory >>$errs 2>&1
checkerr dbz $nhistory

# the following sequence must not fail! Trap errors.
moveerr () {
	cat <<EOF | report -u "$me problems (History update error)"
Moving the new history files in place failed!
This means that the history database may now be corrupted.
##C The news system remains locked for now.
##I The server remains throttled for now.
Human action is urgently needed.
EOF
}

trap 'moveerr; ctlinnd throttle "$mesg"; trap 0; exit 1' 0 1 2 15

if [ "$fuser" ]; then
	$fuser -s -k -TERM $allhistory
fi
rm -f $allhistory || exit 1
sleep $stime
mv $nhistory history || exit 1
mv $nhistory.pag history.pag || exit 1
mv $nhistory.dir history.dir || exit 1

##C unlock LOCK
##C unlock LOCKexpire
##I ctlinnd -s go "$mesg"
##I [ "$fuser" ] && ctlinnd -s readers y "$mesg2"
##I rm -f $Lock
rm -f $errs
trap 0
exit 0
_END_OF_SCRIPT_
