#!/bin/sh
# This is the -*-fundamental-*- source file from which the C News
# and INN versions of expiredaemon are extracted.
# DON'T run this file through "subst" - do that with the extracted file

case "$1" in
C*)	ex='s/^\#\#C *//'; ey='/^\#\#I/d' ;;
I*)	ex='s/^\#\#I *//'; ey='/^\#\#C/d' ;;
*)	exit 1;
esac

#-----------------------------------------------------------------------------#
exec sed -e "$ex" -e "$ey" <<'_END_OF_SCRIPT_'
#!/bin/sh
# expiredaemon - start dexpire in daemon mode (C News spacelist version)

##C # =()<. ${NEWSCONFIG-@<NEWSCONFIG>@}>()=
##C . ${NEWSCONFIG-/var/lib/news/bin/config}
##I # =()<. @<_PATH_SHELLVARS>@>()=
##I . /var/lib/news/innshellvars
##I NEWSCTL=$NEWSLIB # for compatibility

##C PATH=$NEWSCTL/bin:$NEWSBIN/expire:$NEWSBIN:$NEWSPATH
##I PATH=$NEWSBIN:$PATH:/bin:/usr/bin
export PATH NEWSCTL
##C umask $NEWSUMASK
##I umask 002

dpar=1800,86400   # 30m,1d
q=""
v=""
k=""
while [ "$1" ]; do
	case "$1" in
		-q) q=$1 ;;
		-v) v=$1 ;;
		-k) k=$1 ;;
		*) dpar=$1 ;;
	esac
	shift
done

cd $NEWSCTL
##C log=dexpire.log
##C err=dexpire.err
##I log=${MOST_LOGS}/dexpire.log
##I err=${MOST_LOGS}/dexpire.err
me=`basename $0`
##C dexpire=$NEWSBIN/expire/dexpire
##I dexpire=$NEWSBIN/dexpire
##C splist=$NEWSBIN/expire/splist.awk
##I splist=$NEWSBIN/splist.awk

# stop old daemons
daemons=`echo LDexp.*`
if [ ! "$daemons" = 'LDexp.*' ]; then
	for i in $daemons; do
		p=`sed -n -e 1p $i`
		if [ ! "$q" ]; then echo "Stopping $p"; fi
		kill $p 2>/dev/null
		rm -f $i
	done
fi

if [ "$k" ]; then exit; fi

# start new daemons
cnt=1
u="-u"
awk -f $splist $NEWSCTL/spacelist | \
while read fsys ino blk da db; do
	if [ ! "$q" ]; then echo -n "Starting dexpire on $fsys... "; fi
	$dexpire $u $v -S$fsys -i$ino -f$blk -D$dpar -P$NEWSCTL/LDexp.$cnt \
		>> $log 2>> $err &
	if [ ! "$q" ]; then echo "$!"; fi
	cnt=`expr $cnt + 1`
	u=""
done

exit 0
_END_OF_SCRIPT_
