## This file contains functions common to the various scripts.
## It is included by the make process into the generated files.

##I # report trouble to the newsmaster
##    (C News has its own script for that, called "report")
##I report () {
##I 	if [ "$1" = "-u" ]; then shift; UU="URGENT: "; else UU=""; fi
##I 	$MAILCMD -s "$UU$*" "$NEWSMASTER"
##I }

# check completed subprocess for errors
checkerr () {
	s=$?
        em=""
	if [ $s != 0 ]; then
		em="$* exited with status $s"
	fi
	if [ -s $errs -o "$em" ]; then
		echo "$em" | cat - $errs | report "$me problems ($1)"
		exit 1
	fi
}

# make a new expires database
newexpires () {
	echo "Creating an empty expires database" | report "$me: expires db"
	rm -f expires expires.dir expires.pag
	touch expires
	# estimate expires size as 1/20 of history size
	si=`awk '/^[0-9]/ {print int($1/20); exit}' history.dir`
	dbz -p "$si 0 0" expires >>$errs 2>&1
	checkerr dbz expires
}

##I # (attempt to) determine free space on partition
##I diskspace () {
##I # =()<	@<INNWATCH_DF>@ $1 | awk 'NR==2 {print 1024*$@<INNWATCH_BLOCKS>@}'
##I 	/bin/df $1 | awk 'NR==2 {print 1024*$4}'
##I }
##I 
##I # (attempt to) determine space usage by a set of files
##I sizeof () {
##I 	ls -l "$@" | awk '{S+=$5} END {print S}'
##I }
