#ifdef USE_SCANDIR
/*
   scandir()-like routine for news spools.
   Returns a malloced sorted array consisting of valid article numbers.

  (if your compiler barfs on this file, recompile with USE_SCANDIR undefined)
*/

#include <dirent.h>
#include <stdlib.h>

#define CHUNK 256

int
numcmp(a, b)
     int *a, *b;
{
  return *a - *b;
}

/*
   Input: dir - directory to read
   Output: numar - the numbers array
   Return value: number of entries, -1 on failure
*/

int
scannumdir(dir, numar)
     char *dir;
     int **numar;
{
  DIR *d;
  struct dirent *e;
  int *ar=NULL, *a2;
  int n=0, r=0, v;

  if (!(d=opendir(dir)))
    return -1;
  while ((e=readdir(d))) {
    if ((v=atoi(e->d_name))>0) {
      if (!r) {
	if (!(a2=realloc(ar, (1+(n/CHUNK))*CHUNK*sizeof(int)))) {
	  closedir(d);
	  free(ar);
	  return -2;
	}
	ar=a2; r=CHUNK;
      }
      ar[n++]=v;
      --r;
    }
  }
  closedir(d);
  if (n>0)
    qsort(ar, n, sizeof(int), numcmp);
  *numar=ar;
  return n;
}

#endif
